// -*-C++-*-
//
// File:      BinaryFormatter.h
// Author:    Jorgo Bakker (jbakker@rssd.esa.int)
// Generated: Mon Jan 27 17:56:32 CET 2003
// Usage:     -
// Info:      -

#ifndef BinaryFormatter_h
#define BinaryFormatter_h

#include "MessageFormatter.h"

class BinaryFormatter : public /* implementation of */ MessageFormatter
{
public:
  BinaryFormatter();
  virtual ~BinaryFormatter();

  void setInputChannel(int);
  void setOutputChannel(int);
  void setDecodeListener(MessageHandler* handler=0);

  virtual void message(const std::string& name,
		       const std::string& text);

  virtual void warning(const std::string& name,
		       const std::string& code, 
		       const std::string& text);

  virtual void error(const std::string& name,
		     const std::string& code, 
		     const std::string& text);

  virtual void fatal(const std::string& name,
		     const std::string& code, 
		     const std::string& text);

  virtual void decode();

private:
  // member functions
  BinaryFormatter(const BinaryFormatter&);            // copy constructor (disabled)
  BinaryFormatter& operator=(const BinaryFormatter&); // assignment (disabled)

  void write(const std::string&);
  void read(const std::string&);


  // member data
  int _fdi;
  int _fdo;
  MessageHandler* _handler;
};



#endif
