// -*-C++-*-
//
// File:      freezestream.h
// Author:    jbakker
// Generated: Thu Jun 22 15:58:43 MET DST 2000

#ifndef freezestream_h
#define freezestream_h

#include <strstream>

/*
  The GNU sstream (at least in egcs-1.1.1) contains a bug. When using ss.str(),
  it implicitly should freeze(0) the stream, such that proper cleanupis done.

  However, due to the bug, memory is leaking.
 */
inline std::string freezestream(ostrstream& ss)
{
  char *chCopy = ss.str();
  ss.freeze(1);
  std::string result(chCopy);
  delete chCopy;

  return result;
}

inline std::string freezestream(strstream& ss)
{
  char *chCopy = ss.str();
  ss.freeze(1);
  std::string result(chCopy);
  delete chCopy;

  return result;
}


#endif
