#include "../src/SuppressHandler.h"
#include <iostream>

void show(SuppressHandler& s,const Code& c)
{
  if (s.suppress(c)) return;
  std::cout << " # Warning(" << c  << ")" << std::endl;
}

void handle(SuppressHandler& s)
{
  for(int n=0;n<4;n++) {
    show(s,"Foo");
    show(s,"Bar");
    show(s,"Nope");
  }
}

int main(int argc,char** argv)
{
  std::cout << "--- run ---" << std::endl;
  SuppressHandler s;

  // Parse remaining parameters.
  int i = 0;
  while (++i < argc) {
    s.ignore(argv[i]);
  }

  // process
  handle(s);

  // 
  std::cout << " statistics: " << s.statistics() << std::endl;
  std::cout << " options:" << s.options() << std::endl;
  return 0;

}
