#include <errstr.h>
#include <cstdlib>

void a()
{
    errstr << "The global verbosity is " << errHandler.verbosity() << Sas::message(Msg::App,Msg::Silent);
    errstr << "The application verbosity is " << errHandler.verbosity(Msg::App) << Sas::message(Msg::App,Msg::Silent);
    errstr << "This should be shown" << Sas::message(Msg::App,Msg::Sparse);
    errstr << "This should not be shown" << Sas::message(Msg::App,Msg::Verbose);
    errstr << 3.1415927 << " " << std::endl;
    errstr << "looks suspicious";
    errstr << Sas::warning("someWarning");
}

void b()
{
    errstr << 2.7182818 << " " << "looks better" << Sas::error("someError");
}

void c()
{
    errstr << 1.532344 << " " << " is really fatal" << Sas::fatal("someFatalError");
}

void d()
{
    Sas::error("someError","some error");
}

int main(int argc, char *argv[])
{
  errHandler.name(argv[0]);
  int level=4;
  if (argc == 2) level=atoi(argv[1]);
  errHandler.verbosity(level);

  errstr << "Verbosity is set to " << errHandler.verbosity() 
	 << Sas::message(Msg::App,Msg::Always);

  a();
#ifdef EXCEPTIONS
  try { b(); } catch (...) { std::cerr << "an exception was raised" << std::endl; }
  try { c(); } catch (...) { std::cerr << "an exception was raised" << std::endl; }
  try { d(); } catch (...) { std::cerr << "an exception was raised" << std::endl; }
#else
  b();
  c();
  d();
#endif
}

